<script lang="js">

  import RoundButton from './components/RoundButton.svelte';

  let lists = [];
  let currentList = null;
  let currentListLength = null;
  let showAllTasks = false;

  function toggleCompleted() {
    if (showAllTasks === false) showAllTasks = true;
    else showAllTasks = false;
  }

  function getLists() {
    fetch("/api/lists")
      .then(res => {
        if (res.status != 200) throw "Could not get lists";
        return res.json();
      })
      .then(data => {
        lists = data;
      })
      .catch(err => {
        alert(err);
      });
  }
  getLists();

  let newList = {
    title: null
  };
  function addList() {
    fetch("/api/lists", {
      method: "POST",
      headers: {
        Accept: "application/json",
        "Content-type": "application/json"
      },
      body: JSON.stringify(newList)
    })
      .then(res => {
        if (res.status != 200) throw "Could not add list";
        getLists();
      })
      .catch(err => alert(err));
  }

  let todoList = [];

  function refreshList() {
    fetch("/api/tasks")
      .then(res => {
        if (res.status != 200) throw "Not ok";
        return res.json();
      })
      .then(data => {
        todoList = data;
        for (var i = 0; i < todoList.length; i++) {
          todoList[i].editMode = false;
          todoList[i].unsaved = false;
          todoList[i].list_idCache = todoList[i].list_id;
        }
      })
      .catch(err => {
        alert(err);
      });
  }
  refreshList();

  let newTask = {
    title: null,
    description: null
  };
  let addTask = function() {
    if (newTask.title != null) {
      newTask.list_id = currentList;
      fetch("/api/tasks", {
        method: "POST",
        headers: {
          Accept: "application/json",
          "Content-type": "application/json"
        },
        body: JSON.stringify(newTask)
      })
        .then(res => {
          if (res.status != 200) throw "Sorry, an error occured";
          return res.json();
        })
        .then(data => {
          newTask.title = null;
          refreshList();
        })
        .catch(err => {
          alert(err);
        });
    }
  };

  let deleteCurrentList = function() {
    fetch("/api/lists/" + currentList, {
      method: "DELETE",
      headers: {
        Accept: "application/json",
        "Content-type": "application/json"
      }
    })
      .then(res => {
        if (res.status != 200) throw "Sorry, there was an error";
        getLists();
        currentList = null;
      })
      .catch(err => {
        alert(err);
      });
  };

  let deleteTask = function(i) {
    fetch("/api/tasks/" + todoList[i]._id, {
      method: "DELETE",
      headers: {
        Accept: "application/json",
        "Content-type": "application/json"
      }
    })
      .then(res => {
        if (res.status != 200) throw "Sorry, there was an error";
        refreshList();
      })
      .catch(err => {
        alert(err);
      });
  };

  let markUnDone = function(i) {
    fetch("/api/tasks/" + todoList[i]._id, {
      method: "PATCH",
      headers: {
        Accept: "application/json",
        "Content-type": "application/json"
      },
      body: JSON.stringify({
        completed: false
      })
    })
      .then(res => {
        if (res.status != 200) throw "Sorry, there was an error";
        refreshList();
      })
      .catch(err => {
        alert(err);
      });
  };

  let markDone = function(i) {
    fetch("/api/tasks/" + todoList[i]._id, {
      method: "PATCH",
      headers: {
        Accept: "application/json",
        "Content-type": "application/json"
      },
      body: JSON.stringify({
        completed: true
      })
    })
      .then(res => {
        if (res.status != 200) throw "Sorry, there was an error";
        refreshList();
      })
      .catch(err => {
        alert(err);
      });
  };

  let updateTask = async function(i) {
    try {
      var res = await fetch("/api/tasks/" + todoList[i]._id, {
        method: "PATCH",
        headers: {
          Accept: "application/json",
          "Content-type": "application/json"
        },
        body: JSON.stringify({
          title: todoList[i].title,
          description: todoList[i].description,
          list_id: todoList[i].list_idCache
        })
      });
      if (res.status == 200){ 
        todoList[i].unsaved = false;
        todoList[i].list_id = todoList[i].list_idCache; 
      }
      else throw "Could not save";
    } catch (err) {
      todoList[i].unsaved = true;
    }
    todoList[i].editMode = false;
    todoList[i] = todoList[i];
  };
</script>

<style type="text/scss" scoped>
  textarea {
    width: 100%;
  }

  .container {
    justify-self: center;
    align-self: center;
    max-width: 800px;
    background-color: white;
    padding: 2em;
    margin-top: 20px;
    margin-bottom: 20px;
    box-shadow: 0 1px 5px 1px black;
    border-radius: 5px;
  }

  :global(body) {
    display: grid;
    background-image: url("./res/code-bg.jpg");
    background-size: cover;
    background-position: center;
    background-attachment: fixed;
    height: auto;
  }
  :global(html) {
    height: auto;
  }

  .task-list-container {
    max-width: 500px;
    ul {
      padding-left: 0;
      list-style-type: none;
      display: grid;
      grid-template-rows: 1fr;
      padding: 1em;
      li::before {
          content: "";
          box-shadow: 0px 2px 4px 0px gray;
          position: absolute;
          top: 0;
          left: 0;
          right: 0;
          bottom: 0;
          z-index: -1;
      }
      li {
        background-color: white;
        box-sizing: border-box;
        z-index: 1;
        &:first-child {
        }
        // border-bottom: 1px solid gray;
        // border-left: 1px solid gray;
        // border-right: 1px solid gray;
        position: relative;
        padding: 10px;
        display: grid;
        grid-template-columns: 1fr auto;
        .title {
          margin-top: .5em;
          margin-bottom: .5em;
        }
        .description {
          grid-column-start: 1;
          margin-top: 0;
        }
        .category {
          grid-column-start: 1;
          justify-self: end;
        }
        .actions {
          grid-row-start: 1;
          grid-column-start: -1;
          display: flex;
          align-items: center;
        }
        .save {
          grid-column-start: 1;
          justify-self: start;
        }
      }
    }
  }
</style>


<div class="container">
  <h1>Things to Do</h1>
  <button on:click={toggleCompleted}>
    {#if showAllTasks === true}
      Hide completed tasks
    {:else}Show completed tasks{/if}
  </button>
  <h2>Lists</h2>
  {#each lists as list}
    <button
      style="margin: 4px"
      on:click={e => {
        currentList = list._id;
      }}>
      {list.title}
    </button>
  {/each}
  <button
    style="margin: 4px"
    on:click={e => {
      currentList = false;
    }}>
    All
  </button>
  <button
    style="margin: 4px"
    on:click={e => {
      currentList = null;
    }}>
    Uncategorized
  </button>
  <div class="task-list-container">
    <ul>
      {#each todoList as todo, i}
      {#if (showAllTasks || todo.completed === false) && (currentList == false || todo.list_id == currentList)}
      <li>
        {#if todo.editMode !== true}
        <h5 class="title">{todo.title}</h5>
        <p class="description">{todo.description}</p>
        <div class="actions">
          {#if todo.completed === false}
          <RoundButton icon="check" on:click={e => markDone(i)} />
          <RoundButton icon="edit" on:click={e => { todo.editMode = true; todoList[i] = todoList[i] }} />
          {:else}
          <RoundButton icon="x" on:click={e => markUnDone(i)} />
          <RoundButton icon="trash" on:click={e => deleteTask(i)} />
          {/if}
        </div>
        {:else}
        <input type="text" class="title" bind:value={todo.title}/>
        <textarea rows="3" class="description" bind:value={todo.description}></textarea>
        <select bind:value={todo.list_idCache} class="category">
          {#each lists as list}
          <option value={list._id}>{list.title}</option>
          {/each}
        </select>
        <button class="save" on:click={e => updateTask(i)}>Save</button>
        {/if}
      </li>
      {/if}
      {/each}
    </ul>
    <p>
      Found {(() => {
        let count = 0;
        for (let i = 0; i < todoList.length; i++) {
          if (todoList[i].list_id === currentList) count++;
        }
        currentListLength = count;
        return count;
      })()} items in list
    </p>
  </div>

  <h2>Add new Task</h2>
  <input
    id="new-task"
    type="text"
    placehoder="Title"
    bind:value={newTask.title} />
  <br />
  <textarea rows="4" placeholder="Description" bind:value={newTask.description} />
  <br />
  <button on:click={addTask}>Add</button>

  <hr />

  <h2>Add new List</h2>
  <input
    id="new-list"
    type="text"
    placehoder="Title"
    bind:value={newList.title} />
  <button on:click={addList}>Add</button>
</div>

<h1> UI Area 51 </h1>
<p> UI mockups are created here </p>


